VERSION 5.00
Begin VB.UserControl oclTab 
   AutoRedraw      =   -1  'True
   BackColor       =   &H00FFFFFF&
   ClientHeight    =   1095
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   2670
   ControlContainer=   -1  'True
   MousePointer    =   99  'Custom
   ScaleHeight     =   73
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   178
   Begin VB.Timer Timer1 
      Enabled         =   0   'False
      Interval        =   10
      Left            =   1080
      Top             =   360
   End
End
Attribute VB_Name = "oclTab"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
''''''Author : Ong Chin Leng
''''''Email : ocl_0@hotmail.com
''''''Description : Tab control with TabStrip, SSTab and XP styles
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Private Const c_VERSION As String = "1.0"

Option Explicit

Private Declare Function DrawFocusRect Lib "user32" (ByVal hdc As Long, lpRect As RECT) As Long
Private Declare Function GetCursorPos Lib "user32" (lpPoint As POINTAPI) As Long
Private Declare Function GetTextExtentPoint Lib "gdi32" Alias "GetTextExtentPointA" (ByVal hdc As Long, ByVal lpszString As String, ByVal cbString As Long, lpSize As Size) As Long
Private Declare Function TextOut Lib "gdi32" Alias "TextOutA" (ByVal hdc As Long, ByVal x As Long, ByVal Y As Long, ByVal lpString As String, ByVal nCount As Long) As Long
Private Declare Function WindowFromPoint Lib "user32" (ByVal xPoint As Long, ByVal yPoint As Long) As Long

Private Type POINTAPI
        x As Long
        Y As Long
End Type

Private Type RECT
        Left As Long
        Top As Long
        Right As Long
        Bottom As Long
End Type

Private Type Size
        cx As Long
        cy As Long
End Type

Public Enum oclTabStyleEnum
    oclTabStrip = 0
    oclSSTab = 1
    oclXPTab = 2
End Enum

Private Type typTab
    lX          As Long
    lY          As Long
    lWidth      As Long
    lHeight     As Long
    lCaptionX   As Long
    lCaptionY   As Long
    sCaption    As String
    Icon        As StdPicture
End Type
Private m_bResetCaption     As Boolean 'used to set whether to re-calculate the caption's position when painting
Private m_tTab()            As typTab
Private m_bHasFocus         As Boolean
Private m_nOverTab          As Integer 'which tab the cursor is over (-1 if none)

Private m_Style             As oclTabStyleEnum
Private m_nTabs             As Integer
Private m_nCurrentTab       As Integer
Private m_Font              As StdFont
Private m_bShowFocusRect    As Boolean
Private m_bHotTracking      As Boolean
Private m_MouseIcon         As StdPicture

Event Click(PreviousTab As Integer)
Attribute Click.VB_MemberFlags = "200"

Private Sub Timer1_Timer()
    Dim tPos As POINTAPI
    GetCursorPos tPos
    If Not WindowFromPoint(tPos.x, tPos.Y) = UserControl.hwnd Then
        Timer1.Enabled = False
        m_nOverTab = -1
        UserControl_Paint
    End If
End Sub

Private Sub UserControl_GotFocus()
    m_bHasFocus = True
    UserControl_Paint
End Sub

Private Sub UserControl_Initialize()
    m_nOverTab = -1
End Sub

Private Sub UserControl_InitProperties()
    m_nTabs = 1
    ReDim m_tTab(m_nTabs - 1)
    Set m_Font = Ambient.Font
    Set UserControl.Font = m_Font
    m_bShowFocusRect = True
    m_bHotTracking = True
End Sub

Private Sub UserControl_LostFocus()
    m_bHasFocus = False
    UserControl_Paint
End Sub

Private Sub UserControl_MouseDown(Button As Integer, Shift As Integer, x As Single, Y As Single)
    Dim I As Integer
    Dim nTemp As Integer
    
    For I = 0 To m_nTabs - 1
        If x >= m_tTab(I).lX And Y >= m_tTab(I).lY And x <= m_tTab(I).lX + m_tTab(I).lWidth And Y <= m_tTab(I).lY + m_tTab(I).lHeight Then
            If I <> m_nCurrentTab Then
                nTemp = m_nCurrentTab
                m_nCurrentTab = I
                UserControl_Paint
                RaiseEvent Click(nTemp)
                Exit For
            End If
        End If
    Next I
End Sub

Private Sub UserControl_MouseMove(Button As Integer, Shift As Integer, x As Single, Y As Single)
    Dim I As Integer
    
    If m_bHotTracking Then
        m_nOverTab = -1
        Timer1.Enabled = False
        For I = 0 To m_nTabs - 1
            If x >= m_tTab(I).lX And Y >= m_tTab(I).lY And x <= m_tTab(I).lX + m_tTab(I).lWidth And Y <= m_tTab(I).lY + m_tTab(I).lHeight Then
                m_nOverTab = I
                UserControl.MouseIcon = m_MouseIcon
                Timer1.Enabled = True
                Exit For
            End If
        Next I
        UserControl_Paint
        If m_nOverTab = -1 Then UserControl.MouseIcon = Nothing
    End If
End Sub

Private Sub UserControl_Paint()
    Select Case m_Style
        Case 0
            DrawTabStrip m_nCurrentTab, m_nOverTab
        Case 1
            DrawSSTab m_nCurrentTab, m_nOverTab
        Case 2
            DrawXPTab m_nCurrentTab, m_nOverTab
    End Select
    
    'draw the tabs' hitboxes
'    Dim i As Integer
'    For i = 0 To m_nTabs - 1
'        PSet (m_tTab(i).lX, m_tTab(i).lY), vbRed
'        PSet (m_tTab(i).lX + m_tTab(i).lWidth, m_tTab(i).lY), vbRed
'        PSet (m_tTab(i).lX + m_tTab(i).lWidth, m_tTab(i).lY + m_tTab(i).lHeight), vbRed
'        PSet (m_tTab(i).lX, m_tTab(i).lY + m_tTab(i).lHeight), vbRed
'    Next i
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    Dim I As Integer
    
    With PropBag
        m_Style = .ReadProperty("Style", 0)
        m_nTabs = .ReadProperty("Tabs", 1)
        ReDim m_tTab(m_nTabs - 1)
        For I = 0 To m_nTabs - 1
            m_tTab(I).sCaption = .ReadProperty("TabCaption" & CStr(I), vbNullString)
            Set m_tTab(I).Icon = .ReadProperty("TabIcon" & CStr(I), Nothing)
        Next I
        m_nCurrentTab = .ReadProperty("CurrentTab", 0)
        Set m_Font = .ReadProperty("Font", Ambient.Font)
        Set UserControl.Font = m_Font
        m_bShowFocusRect = .ReadProperty("ShowFocusRect", True)
        m_bHotTracking = .ReadProperty("HotTracking", True)
        Set m_MouseIcon = .ReadProperty("MouseIcon", Nothing)
        
        m_bResetCaption = False
        UserControl_Paint
    End With
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    Dim I As Integer
    
    With PropBag
        .WriteProperty "Style", m_Style
        .WriteProperty "Tabs", m_nTabs
        For I = 0 To m_nTabs - 1
            .WriteProperty "TabCaption" & CStr(I), m_tTab(I).sCaption
            .WriteProperty "TabIcon" & CStr(I), m_tTab(I).Icon
        Next I
        .WriteProperty "CurrentTab", m_nCurrentTab
        .WriteProperty "Font", m_Font
        .WriteProperty "ShowFocusRect", m_bShowFocusRect
        .WriteProperty "HotTracking", m_bHotTracking
        .WriteProperty "MouseIcon", m_MouseIcon
    End With
End Sub

Private Sub UserControl_Resize()
    UserControl_Paint
End Sub

Private Sub DrawTabStrip(ByVal nSelected As Integer, ByVal nOver As Integer)
    Const XSPACE As Integer = 10 'horizontal extra room
    Const YSPACE As Integer = 6 'vertical extra room
    Const XOFFSET As Integer = 2 'distance from userctl.left to first tab
    Const YOFFSET As Integer = 2 'distance from userctl.top to tab
    Const XYEDGE As Integer = 2 'width/height of the tab's top edge
    Const XYICON As Integer = 16 'icon width/height
    Const ICONSEP As Integer = 2 'distance between icon and caption
    Const XYFOCUSRECT As Integer = 1 'size decrease from TabRect to FocusRect
    
    Dim I               As Integer
    Dim J               As Integer
    Dim sCaption        As String
    Dim tSize           As Size
    Dim lX              As Long
    Dim lY              As Long
    Dim xPos            As Long
    Dim yPos            As Long
    Dim tRect           As RECT
    Dim lPrevColor      As OLE_COLOR
    Dim bColorChange    As Boolean
    
    If m_nTabs = 0 Then Exit Sub
    
    UserControl.Cls
    
    For I = 0 To m_nTabs - 1
        
        'calculate tab width and height
        sCaption = m_tTab(I).sCaption
        If sCaption = vbNullString Then sCaption = Space(1)
        GetTextExtentPoint UserControl.hdc, sCaption, Len(sCaption), tSize
        If I = nSelected Then
            m_tTab(I).lWidth = tSize.cx + (XOFFSET * 2) + XSPACE
        Else
            m_tTab(I).lWidth = tSize.cx + XSPACE
        End If
        If Not m_tTab(I).Icon Is Nothing Then
            m_tTab(I).lWidth = XYICON + ICONSEP + m_tTab(I).lWidth
        End If
        m_tTab(I).lHeight = tSize.cy + YSPACE
        
        'calculate tab x-pos and y-pos
        If I = nSelected Then
            m_tTab(I).lX = xPos
        Else
            m_tTab(I).lX = IIf(I <> 0, xPos + 1, xPos + XOFFSET)
        End If
        m_tTab(I).lY = YOFFSET
        
        'calculate position of caption
        If Not m_bResetCaption Then 're-calculate caption position only when caption changed or icon added
            m_tTab(I).lCaptionX = m_tTab(I).lX + (m_tTab(I).lWidth - tSize.cx) \ 2
            If Not m_tTab(I).Icon Is Nothing Then
                m_tTab(I).lCaptionX = m_tTab(I).lCaptionX + ((XYICON + ICONSEP) \ 2)
            End If
        End If
        m_tTab(I).lCaptionY = (m_tTab(I).lY + (m_tTab(I).lHeight - tSize.cy) \ 2) + 1
        
        'draw caption
        lX = m_tTab(I).lCaptionX
        lY = IIf(I = nSelected, m_tTab(I).lCaptionY - 1, m_tTab(I).lCaptionY)
        bColorChange = False
        If I = nOver Then
            lPrevColor = UserControl.ForeColor
            UserControl.ForeColor = &H800000
            bColorChange = True
        End If
        TextOut UserControl.hdc, lX, lY, sCaption, Len(sCaption)
        If bColorChange Then
            UserControl.ForeColor = lPrevColor
        End If
        
        'calculate and draw position of icon
        If Not m_tTab(I).Icon Is Nothing Then
            lX = m_tTab(I).lCaptionX - ICONSEP - XYICON
            lY = (m_tTab(I).lY + (m_tTab(I).lHeight - XYICON) \ 2) + 1
            lY = IIf(I = nSelected, lY - 1, lY)
            PaintPicture m_tTab(I).Icon, lX, lY, XYICON, XYICON
        End If
        
        xPos = m_tTab(I).lX 'xPos is used to indicate position when drawing from left to right
        
        'draw tab left vertical line
        If I - 1 <> nSelected Then
            If I = nSelected Then
                Line (xPos, YOFFSET)-(xPos, (m_tTab(I).lY + m_tTab(I).lHeight) + 1), vb3DHighlight
                Line (xPos + 1, YOFFSET)-(xPos + 1, (m_tTab(I).lY + m_tTab(I).lHeight) + 1), vb3DLight
            Else
                Line (xPos, YOFFSET + XYEDGE)-(xPos, m_tTab(I).lY + m_tTab(I).lHeight), vb3DHighlight
                Line (xPos + 1, YOFFSET + XYEDGE)-(xPos + 1, m_tTab(I).lY + m_tTab(I).lHeight), vb3DLight
            End If
            xPos = xPos + 1
            If I = nSelected Then
                PSet (xPos, YOFFSET - 1), vb3DHighlight
            Else
                PSet (xPos, (YOFFSET + XYEDGE) - 1), vb3DHighlight
            End If
        Else
            xPos = m_tTab(I).lX - 1 'tweak
        End If
        
        'draw tab top horizontal line
        If I - 1 = nSelected Then
            m_tTab(I).lX = m_tTab(I).lX - XYEDGE
        End If
        lX = xPos + 1
        xPos = xPos + m_tTab(I).lWidth - XYEDGE
        If I = nSelected Then
            Line (lX, YOFFSET - 2)-(xPos, YOFFSET - 2), vb3DHighlight
            Line (lX, YOFFSET - 1)-(xPos, YOFFSET - 1), vb3DLight
        Else
            Line (lX, YOFFSET)-(xPos, YOFFSET), vb3DHighlight
            Line (lX, YOFFSET + 1)-(xPos, YOFFSET + 1), vb3DLight
        End If
        
        'draw tab right vertical line
        If I + 1 <> nSelected Then
            If I = nSelected Then
                PSet (xPos, YOFFSET - 1), vb3DDKShadow
                Line (xPos, YOFFSET)-(xPos, (m_tTab(I).lY + m_tTab(I).lHeight) + 1), vb3DShadow
                xPos = xPos + 1
                Line (xPos, YOFFSET)-(xPos, (m_tTab(I).lY + m_tTab(I).lHeight) + 1), vb3DDKShadow
            Else
                PSet (xPos, (YOFFSET + XYEDGE) - 1), vb3DDKShadow
                Line (xPos, YOFFSET + XYEDGE)-(xPos, m_tTab(I).lY + m_tTab(I).lHeight), vb3DShadow
                xPos = xPos + 1
                Line (xPos, YOFFSET + XYEDGE)-(xPos, m_tTab(I).lY + m_tTab(I).lHeight), vb3DDKShadow
            End If
        End If
        
        'calculate and draw focus rectangle
        If m_bHasFocus And I = nSelected And m_bShowFocusRect Then
            With tRect
                .Bottom = m_tTab(I).lY + m_tTab(I).lHeight - XYFOCUSRECT
                .Left = (m_tTab(I).lX + XYFOCUSRECT) + 2
                .Right = (m_tTab(I).lX + m_tTab(I).lWidth - XYFOCUSRECT) - 1
                .Top = m_tTab(I).lY + XYFOCUSRECT
            End With
            DrawFocusRect UserControl.hdc, tRect
        End If
        
    Next I
    
    lX = UserControl.Width \ Screen.TwipsPerPixelX - 1
    lY = UserControl.Height \ Screen.TwipsPerPixelY - 1
    xPos = m_tTab(nSelected).lX + m_tTab(nSelected).lWidth
    yPos = m_tTab(nSelected).lY + m_tTab(nSelected).lHeight
    
    'draw line from userctl.left to selected tab
    Line (0, yPos)-(m_tTab(nSelected).lX, yPos), vb3DHighlight
    Line (0, yPos + 1)-(m_tTab(nSelected).lX, yPos + 1), vb3DLight
    
    'draw line from selected tab to userctl.right
    Line (xPos + 3, yPos)-(lX, yPos), vb3DHighlight
    Line (xPos + 3, yPos + 1)-(lX, yPos + 1), vb3DLight
    
    'draw left vertical border
    Line (0, yPos)-(0, lY), vb3DHighlight
    Line (1, yPos + 1)-(1, lY), vb3DLight
    
    'draw right vertical border
    Line (lX - 1, yPos + 1)-(lX - 1, lY), vb3DShadow
    Line (lX, yPos)-(lX, lY + 1), vb3DDKShadow
    
    'draw bottom horizontal border
    Line (1, lY - 1)-(lX, lY - 1), vb3DShadow
    Line (0, lY)-(lX + 1, lY), vb3DDKShadow

    If Not m_bResetCaption Then m_bResetCaption = True
End Sub

Private Sub DrawSSTab(ByVal nSelected As Integer, ByVal nOver As Integer)
    Const XSPACE As Integer = 20 'horizontal extra room
    Const YSPACE As Integer = 4 'vertical extra room
    Const XYOFFSET As Integer = 4 'width/height of the tab's top edge
    Const XYICON As Integer = 16 'icon width/height
    Const ICONSEP As Integer = 2 'distance between icon and caption
    Const XYFOCUSRECT As Integer = 1 'size increase from CaptionRect to FocusRect
    
    Dim I               As Integer
    Dim sCaption        As String
    Dim tNormalSize     As Size
    Dim tBoldSize       As Size
    Dim xPos            As Long
    Dim yPos            As Long
    Dim xPrevPos        As Long
    Dim bFontChange     As Boolean
    Dim lX              As Long
    Dim lY              As Long
    Dim tRect           As RECT
    Dim lPrevColor      As OLE_COLOR
    Dim bColorChange    As Boolean
    
    If m_nTabs = 0 Then Exit Sub
    
    UserControl.Cls
    
    For I = 0 To m_nTabs - 1
        
        'calculate tab width and height
        sCaption = m_tTab(I).sCaption
        If sCaption = vbNullString Then sCaption = Space(1)
        bFontChange = UserControl.Font.Bold
        UserControl.Font.Bold = True
        GetTextExtentPoint UserControl.hdc, sCaption, Len(sCaption), tBoldSize
        UserControl.Font.Bold = False
        GetTextExtentPoint UserControl.hdc, sCaption, Len(sCaption), tNormalSize
        UserControl.Font.Bold = bFontChange
        m_tTab(I).lWidth = tBoldSize.cx + XYOFFSET + XSPACE
        If Not m_tTab(I).Icon Is Nothing Then
            m_tTab(I).lWidth = XYICON + ICONSEP + m_tTab(I).lWidth
        End If
        m_tTab(I).lHeight = tBoldSize.cy + XYOFFSET + YSPACE
        
        'calculate tab x-pos and y-pos
        m_tTab(I).lX = xPos
        m_tTab(I).lY = 0
        
        'calculate position of caption
        If I = nSelected And Not UserControl.Font.Bold Then
            m_tTab(I).lCaptionX = m_tTab(I).lX + (m_tTab(I).lWidth - tBoldSize.cx) \ 2
            m_tTab(I).lCaptionY = m_tTab(I).lY + (m_tTab(I).lHeight - tBoldSize.cy) \ 2
        ElseIf UserControl.Font.Bold Then
            m_tTab(I).lCaptionX = m_tTab(I).lX + (m_tTab(I).lWidth - tBoldSize.cx) \ 2
            m_tTab(I).lCaptionY = m_tTab(I).lY + (m_tTab(I).lHeight - tBoldSize.cy) \ 2
        Else
            m_tTab(I).lCaptionX = m_tTab(I).lX + (m_tTab(I).lWidth - tNormalSize.cx) \ 2
            m_tTab(I).lCaptionY = m_tTab(I).lY + (m_tTab(I).lHeight - tNormalSize.cy) \ 2
        End If
        If Not m_tTab(I).Icon Is Nothing Then
            m_tTab(I).lCaptionX = m_tTab(I).lCaptionX + ((XYICON + ICONSEP) \ 2)
        End If
        If I = nSelected Then m_tTab(I).lCaptionY = m_tTab(I).lCaptionY + 1
        
        'draw caption
        bFontChange = False
        If I = nSelected And Not UserControl.Font.Bold Then
            UserControl.Font.Bold = True
            bFontChange = True
        End If
        bColorChange = False
        If I = nOver Then
            lPrevColor = UserControl.ForeColor
            UserControl.ForeColor = &H800000
            bColorChange = True
        End If
        TextOut UserControl.hdc, m_tTab(I).lCaptionX, m_tTab(I).lCaptionY, sCaption, Len(sCaption)
        If bFontChange Then
            UserControl.Font.Bold = False
        End If
        If bColorChange Then
            UserControl.ForeColor = lPrevColor
        End If
        
        'calculate and draw position of icon
        If Not m_tTab(I).Icon Is Nothing Then
            lX = m_tTab(I).lCaptionX - ICONSEP - XYICON
            lY = (m_tTab(I).lY + (m_tTab(I).lHeight - XYICON) \ 2) + 1
            PaintPicture m_tTab(I).Icon, lX, IIf(I = nSelected, lY + 1, lY), XYICON, XYICON
        End If
        
        If I <> nSelected Then 'draw non-selected tab
        
            'draw tab left vertical line
            xPos = m_tTab(I).lX
            Line (xPos, m_tTab(I).lY + XYOFFSET)-(xPos, m_tTab(I).lY + m_tTab(I).lHeight), vbBlack
            Line (xPos + 1, m_tTab(I).lY + XYOFFSET)-(xPos + 1, m_tTab(I).lY + m_tTab(I).lHeight), vbWhite
            
            'draw tab top-left line
            xPrevPos = xPos
            xPos = xPos + XYOFFSET
            Line (xPrevPos, m_tTab(I).lY + XYOFFSET)-(xPos, m_tTab(I).lY), vbBlack
            Line (xPrevPos + 1, m_tTab(I).lY + XYOFFSET)-(xPos, m_tTab(I).lY + 1), vbWhite
            
            'draw tab top horizontal line
            xPrevPos = xPos
            xPos = xPos + m_tTab(I).lWidth - (XYOFFSET * 2)
            Line (xPrevPos, m_tTab(I).lY)-(xPos, m_tTab(I).lY), vbBlack
            Line (xPrevPos, m_tTab(I).lY + 1)-(xPos, m_tTab(I).lY + 1), vbWhite
            
            'draw tab top-right line
            xPrevPos = xPos
            xPos = xPos + XYOFFSET
            Line (xPrevPos, m_tTab(I).lY)-(xPos, m_tTab(I).lY + XYOFFSET), vbBlack
            Line (xPrevPos, m_tTab(I).lY + 1)-(xPos - 1, m_tTab(I).lY + XYOFFSET), vb3DShadow
            
            'draw tab right vertical line
            xPos = xPos - 1
            Line (xPos, m_tTab(I).lY + XYOFFSET)-(xPos, m_tTab(I).lY + m_tTab(I).lHeight), vb3DShadow
            Line (xPos + 1, m_tTab(I).lY + XYOFFSET)-(xPos + 1, m_tTab(I).lY + m_tTab(I).lHeight), vbBlack
            
            xPos = xPos + 1
        
        Else 'draw selected tab
        
            'draw tab left vertical line
            xPos = m_tTab(I).lX
            Line (xPos, m_tTab(I).lY + XYOFFSET)-(xPos, m_tTab(I).lY + m_tTab(I).lHeight), vbBlack
            Line (xPos + 1, m_tTab(I).lY + XYOFFSET)-(xPos + 1, (m_tTab(I).lY + m_tTab(I).lHeight) + 1), vb3DHighlight
            Line (xPos + 2, m_tTab(I).lY + XYOFFSET)-(xPos + 2, (m_tTab(I).lY + m_tTab(I).lHeight) + 1), vb3DHighlight
            
            'draw tab top-left line
            xPrevPos = xPos
            xPos = xPos + XYOFFSET
            Line (xPrevPos, m_tTab(I).lY + XYOFFSET)-(xPos, m_tTab(I).lY), vbBlack
            Line (xPrevPos + 1, m_tTab(I).lY + XYOFFSET)-(xPos + 1, m_tTab(I).lY + 1), vb3DHighlight
            Line (xPrevPos + 2, m_tTab(I).lY + XYOFFSET)-(xPos + 1, m_tTab(I).lY + 2), vb3DHighlight
            Line (xPrevPos + 3, m_tTab(I).lY + XYOFFSET)-(xPos + 1, m_tTab(I).lY + 3), vb3DHighlight
            
            'draw tab top horizontal line
            xPrevPos = xPos
            xPos = xPos + m_tTab(I).lWidth - (XYOFFSET * 2)
            Line (xPrevPos, m_tTab(I).lY)-(xPos, m_tTab(I).lY), vbBlack
            Line (xPrevPos, m_tTab(I).lY + 1)-(xPos + 1, m_tTab(I).lY + 1), vb3DHighlight
            Line (xPrevPos, m_tTab(I).lY + 2)-(xPos, m_tTab(I).lY + 2), vb3DHighlight
            
            'draw tab top-right line
            xPrevPos = xPos
            xPos = xPos + XYOFFSET
            Line (xPrevPos, m_tTab(I).lY)-(xPos, m_tTab(I).lY + XYOFFSET), vbBlack
            Line (xPrevPos + 1, (m_tTab(I).lY + 1) + 1)-(xPos - 1, m_tTab(I).lY + XYOFFSET), vb3DShadow
            Line (xPrevPos, m_tTab(I).lY + 2)-(xPos - 2, m_tTab(I).lY + XYOFFSET), vb3DShadow
            Line (xPrevPos, m_tTab(I).lY + 3)-(xPos - 2, (m_tTab(I).lY + XYOFFSET) + 1), vb3DShadow
            
            'draw tab right vertical line
            xPos = xPos - 2
            Line (xPos, m_tTab(I).lY + XYOFFSET)-(xPos, (m_tTab(I).lY + m_tTab(I).lHeight) + 3), vb3DShadow
            Line (xPos + 1, m_tTab(I).lY + XYOFFSET)-(xPos + 1, (m_tTab(I).lY + m_tTab(I).lHeight) + 3), vb3DShadow
            Line (xPos + 2, m_tTab(I).lY + XYOFFSET)-(xPos + 2, m_tTab(I).lY + m_tTab(I).lHeight), vbBlack
            
            xPos = xPos + 2
        
        End If
        
        'calculate and draw focus rectangle
        If m_bHasFocus And I = nSelected And m_bShowFocusRect Then
            With tRect
                .Bottom = (m_tTab(I).lCaptionY + tBoldSize.cy + XYFOCUSRECT) + 1
                .Left = (m_tTab(I).lCaptionX - XYFOCUSRECT) - 2
                .Right = m_tTab(I).lCaptionX + tBoldSize.cx
                .Top = m_tTab(I).lCaptionY - XYFOCUSRECT
            End With
            DrawFocusRect UserControl.hdc, tRect
        End If
        
    Next I
    
    lX = UserControl.Width \ Screen.TwipsPerPixelX - 1
    lY = UserControl.Height \ Screen.TwipsPerPixelY - 1
    xPos = m_tTab(nSelected).lX + m_tTab(nSelected).lWidth
    yPos = m_tTab(nSelected).lY + m_tTab(nSelected).lHeight
    
    'draw line from userctl.left to selected tab
    Line (0, yPos)-(m_tTab(nSelected).lX + 1, yPos), vbBlack
    Line (0, yPos + 1)-(m_tTab(nSelected).lX + 3, yPos + 1), vb3DHighlight
    Line (0, yPos + 2)-(m_tTab(nSelected).lX + 3, yPos + 2), vb3DHighlight
    
    'draw line from selected tab to userctl.right
    Line (xPos, yPos)-(lX, yPos), vbBlack
    Line (xPos - 1, yPos + 1)-(lX, yPos + 1), vb3DHighlight
    Line (xPos - 2, yPos + 2)-(lX, yPos + 2), vb3DHighlight
    
    'draw left vertical border
    Line (0, yPos + 1)-(0, lY), vbBlack
    Line (1, yPos + 1)-(1, lY), vb3DHighlight
    Line (2, yPos + 1)-(2, lY), vb3DHighlight
    
    'draw right vertical border
    Line (lX - 2, yPos + 2)-(lX - 2, lY), vb3DShadow
    Line (lX - 1, yPos + 1)-(lX - 1, lY), vb3DShadow
    Line (lX, yPos)-(lX, lY + 1), vbBlack
    
    'draw bottom horizontal border
    Line (3, lY - 2)-(lX, lY - 2), vb3DShadow
    Line (2, lY - 1)-(lX, lY - 1), vb3DShadow
    Line (0, lY)-(lX + 1, lY), vbBlack
End Sub

Private Sub DrawXPTab(ByVal nSelected As Integer, ByVal nOver As Integer)
    Const XSPACE As Integer = 10 'horizontal extra room
    Const YSPACE As Integer = 6 'vertical extra room
    Const XOFFSET As Integer = 2 'distance from userctl.left to first tab
    Const YOFFSET As Integer = 2 'distance from userctl.top to tab
    Const XYEDGE As Integer = 2 'width/height of the tab's top edge
    Const XYICON As Integer = 16 'icon width/height
    Const ICONSEP As Integer = 2 'distance between icon and caption
    
    Dim XP_BORDERCOLOR  As Long: XP_BORDERCOLOR = RGB(145, 167, 180)
    Dim XP_DARKSHADOW   As Long: XP_DARKSHADOW = RGB(145, 155, 156)
    Dim XP_LIGHTSHADOW  As Long: XP_LIGHTSHADOW = RGB(224, 221, 212)
    
    Dim I           As Integer
    Dim sCaption    As String
    Dim tSize       As Size
    Dim lX          As Long
    Dim lY          As Long
    Dim xPos        As Long
    Dim yPos        As Long
    
    If m_nTabs = 0 Then Exit Sub
    
    UserControl.Cls
    
    For I = 0 To m_nTabs - 1
    
        'calculate tab width and height
        sCaption = m_tTab(I).sCaption
        If sCaption = vbNullString Then sCaption = Space(1)
        GetTextExtentPoint UserControl.hdc, sCaption, Len(sCaption), tSize
        If I = nSelected Then
            m_tTab(I).lWidth = tSize.cx + (XOFFSET * 2) + XSPACE
        Else
            m_tTab(I).lWidth = tSize.cx + XSPACE
        End If
        If Not m_tTab(I).Icon Is Nothing Then
            m_tTab(I).lWidth = XYICON + ICONSEP + m_tTab(I).lWidth
        End If
        m_tTab(I).lHeight = tSize.cy + YSPACE
        
        'calculate tab x-pos and y-pos
        If I = nSelected Then
            m_tTab(I).lX = xPos
        Else
            m_tTab(I).lX = IIf(I <> 0, xPos + 1, xPos + XOFFSET)
        End If
        m_tTab(I).lY = YOFFSET
        
        'fill color into tab area
        lX = m_tTab(I).lX + m_tTab(I).lWidth - 3
        lY = m_tTab(I).lY + m_tTab(I).lHeight
        If I - 1 = nSelected Then
            'Line (m_tTab(i).lX - 1, m_tTab(i).lY + 1)-(lX - 2, lY), vbWhite, BF
            XPGradient m_tTab(I).lX - 1, m_tTab(I).lY + 1, lX - 2, lY
        ElseIf I = nSelected Then
            Line (m_tTab(I).lX + 1, m_tTab(I).lY + 1)-(lX, lY), RGB(252, 252, 254), BF
        Else
            'Line (m_tTab(i).lX + 1, m_tTab(i).lY + 1)-(lX, lY), vbWhite, BF
            XPGradient m_tTab(I).lX + 1, m_tTab(I).lY + 1, lX, lY
        End If
        
        'calculate position of caption
        If Not m_bResetCaption Then
            m_tTab(I).lCaptionX = m_tTab(I).lX + (m_tTab(I).lWidth - tSize.cx) \ 2
            If Not m_tTab(I).Icon Is Nothing Then
                m_tTab(I).lCaptionX = m_tTab(I).lCaptionX + ((XYICON + ICONSEP) \ 2)
            End If
        End If
        m_tTab(I).lCaptionY = (m_tTab(I).lY + (m_tTab(I).lHeight - tSize.cy) \ 2) + 1
        
        'draw caption
        lX = m_tTab(I).lCaptionX
        lY = IIf(I = nSelected, m_tTab(I).lCaptionY - 1, m_tTab(I).lCaptionY)
        TextOut UserControl.hdc, lX, lY, sCaption, Len(sCaption)
        
        xPos = m_tTab(I).lX
        
        'draw tab left vertical line
        If I - 1 <> nSelected Then
            If I = nSelected Then
                Line (xPos, YOFFSET)-(xPos, (m_tTab(I).lY + m_tTab(I).lHeight) + 1), IIf(I = 0, XP_DARKSHADOW, XP_BORDERCOLOR)
                'Line (xPos + 1, YOFFSET)-(xPos + 1, (m_tTab(i).lY + m_tTab(i).lHeight) + 1), vb3DLight
            Else
                Line (xPos, YOFFSET + XYEDGE)-(xPos, m_tTab(I).lY + m_tTab(I).lHeight), XP_BORDERCOLOR
                'Line (xPos + 1, YOFFSET + XYEDGE)-(xPos + 1, m_tTab(i).lY + m_tTab(i).lHeight), vb3DLight
            End If
            xPos = xPos + 1
            If I = nSelected Then
                PSet (xPos, YOFFSET - 1), XP_BORDERCOLOR
            Else
                PSet (xPos, (YOFFSET + XYEDGE) - 1), XP_BORDERCOLOR
            End If
        Else
            xPos = m_tTab(I).lX - 1
        End If
        
        'draw tab top horizontal line
        If I - 1 = nSelected Then
            m_tTab(I).lX = m_tTab(I).lX - XYEDGE
        End If
        lX = xPos + 1
        xPos = xPos + m_tTab(I).lWidth - XYEDGE
        xPos = xPos - 1 'xp tweak
        yPos = (YOFFSET + m_tTab(I).lHeight) - 1 'horizontal shadow y-pos at bottom of tab
        If I = nSelected Then
            'Line (lX, YOFFSET - 2)-(xPos, YOFFSET - 2), XP_BORDERCOLOR
            'Line (lX, YOFFSET - 1)-(xPos, YOFFSET - 1), XP_LIGHTSHADOW
            
            'draw focus orange lines
            Line (lX, YOFFSET - 2)-(xPos, YOFFSET - 2), RGB(230, 139, 44)
            Line (lX, YOFFSET - 1)-(xPos, YOFFSET - 1), RGB(255, 200, 60)
            Line (lX - 1, YOFFSET)-(xPos + 1, YOFFSET), RGB(255, 199, 60)
        
        ElseIf I + 1 = nSelected Then 'xp tweak
            If I = nOver Then
                Line (lX, YOFFSET)-(xPos + 1, YOFFSET), RGB(230, 139, 44)
                Line (lX, YOFFSET + 1)-(xPos + 1, YOFFSET + 1), RGB(255, 200, 60)
                Line (lX - 1, YOFFSET + 2)-(xPos + 2, YOFFSET + 2), RGB(255, 199, 60)
            Else
                Line (lX, YOFFSET)-(xPos + 1, YOFFSET), XP_BORDERCOLOR
                Line (lX, yPos)-(xPos + 1, yPos), XP_LIGHTSHADOW
            End If
        ElseIf I - 1 = nSelected Then 'xp tweak
            If I = nOver Then
                Line (lX - 1, YOFFSET)-(xPos, YOFFSET), RGB(230, 139, 44)
                Line (lX - 1, YOFFSET + 1)-(xPos, YOFFSET + 1), RGB(255, 200, 60)
                Line (lX - 2, YOFFSET + 2)-(xPos + 1, YOFFSET + 2), RGB(255, 199, 60)
            Else
                Line (lX - 1, YOFFSET)-(xPos, YOFFSET), XP_BORDERCOLOR
                Line (lX - 1, yPos)-(xPos, yPos), XP_LIGHTSHADOW
            End If
        Else
            If I = nOver Then
                Line (lX, YOFFSET)-(xPos, YOFFSET), RGB(230, 139, 44)
                Line (lX, YOFFSET + 1)-(xPos, YOFFSET + 1), RGB(255, 200, 60)
                Line (lX - 1, YOFFSET + 2)-(xPos + 1, YOFFSET + 2), RGB(255, 199, 60)
            Else
                Line (lX, YOFFSET)-(xPos, YOFFSET), XP_BORDERCOLOR
                Line (lX, yPos)-(xPos, yPos), XP_LIGHTSHADOW
            End If
        End If
        
        'draw tab right vertical line
        If I + 1 <> nSelected Then
            If I = nSelected Then
                PSet (xPos, YOFFSET - 1), XP_BORDERCOLOR
                Line (xPos, YOFFSET + 1)-(xPos, (m_tTab(I).lY + m_tTab(I).lHeight) + 1), XP_LIGHTSHADOW
                xPos = xPos + 1
                Line (xPos, YOFFSET)-(xPos, (m_tTab(I).lY + m_tTab(I).lHeight) + 1), XP_DARKSHADOW
            Else
                PSet (xPos, (YOFFSET + XYEDGE) - 1), XP_BORDERCOLOR
                Line (xPos, YOFFSET + XYEDGE)-(xPos, m_tTab(I).lY + m_tTab(I).lHeight), XP_LIGHTSHADOW
                xPos = xPos + 1
                Line (xPos, YOFFSET + XYEDGE)-(xPos, m_tTab(I).lY + m_tTab(I).lHeight), XP_BORDERCOLOR
            End If
        End If
        
        'calculate and draw position of icon
        If Not m_tTab(I).Icon Is Nothing Then
            lX = m_tTab(I).lCaptionX - ICONSEP - XYICON
            lY = (m_tTab(I).lY + (m_tTab(I).lHeight - XYICON) \ 2) + 1
            lY = IIf(I = nSelected, lY - 1, lY)
            PaintPicture m_tTab(I).Icon, lX, lY, XYICON, XYICON
        End If
        
        xPos = xPos + 1 'xp tweak
        
    Next I
    
    lX = UserControl.Width \ Screen.TwipsPerPixelX - 1
    lY = UserControl.Height \ Screen.TwipsPerPixelY - 1
    xPos = m_tTab(nSelected).lX + m_tTab(nSelected).lWidth
    yPos = m_tTab(nSelected).lY + m_tTab(nSelected).lHeight
    
    'draw line from userctl.left to selected tab
    Line (0, yPos)-(m_tTab(nSelected).lX, yPos), XP_DARKSHADOW
    
    'draw line from selected tab to userctl.right
    Line (xPos, yPos)-(lX, yPos), XP_DARKSHADOW
    
    'draw left vertical border
    Line (0, yPos)-(0, lY), XP_DARKSHADOW
    
    'draw right vertical border
    Line (lX - 2, yPos)-(lX - 2, lY), XP_DARKSHADOW
    Line (lX - 1, yPos)-(lX - 1, lY - 1), RGB(227, 224, 208)
    Line (lX, yPos)-(lX, lY - 2), RGB(227, 224, 208)
    
    'draw bottom horizontal border
    Line (0, lY - 2)-(lX, lY - 2), XP_DARKSHADOW
    Line (0, lY - 1)-(lX - 1, lY - 1), RGB(227, 224, 208)
    Line (0, lY)-(lX - 2, lY), RGB(227, 224, 208)
    
    Line (lX - 1, yPos + 1)-(lX - 1, lY - 1), RGB(208, 206, 191)
    Line (1, lY - 1)-(lX - 1, lY - 1), RGB(208, 206, 191)
    
    'fill color into frame area
    'Line (1, yPos + 1)-(lX - 3, lY - 3), vbWhite, BF
    XPGradient 1, yPos + 1, lX - 3, lY - 3

    If Not m_bResetCaption Then m_bResetCaption = True
End Sub

'draws XP background gradient from top to bottom, simple way but not right looking
Private Sub XPGradient(ByVal xSrc As Long, ByVal ySrc As Long, ByVal xDest As Long, ByVal yDest As Long)
    Dim I As Integer
    Dim R As Integer, G As Integer, B As Integer
    Dim lHeight As Long
    
    R = 252: G = 252: B = 254
    lHeight = yDest - ySrc
    For I = ySrc To yDest
        Line (xSrc, I)-(xDest + 1, I), RGB(R, G, B)
        If R > 244 Then R = R - Rnd(11 / lHeight)
        If G > 243 Then G = G - Rnd(12 / lHeight)
        If B > 238 Then B = B - Rnd(17 / lHeight)
    Next I
End Sub

Public Sub AboutBox()
Attribute AboutBox.VB_UserMemId = -552
'    MsgBox "OCL Tab Control v" & c_VERSION & vbCrLf & _
'    "Copyright  2002" & vbCrLf & vbCrLf & _
'    "Author : Ong Chin Leng" & vbCrLf & _
'    "Email : ocl_0@hotmail.com", _
'    vbInformation + vbOKOnly, "About"
End Sub

Public Property Get Font() As StdFont
Attribute Font.VB_Description = "Returns a Font object."
    Set Font = m_Font
End Property

Public Property Set Font(ByVal vNewValue As StdFont)
    Set m_Font = vNewValue
    PropertyChanged "Font"
    Set UserControl.Font = m_Font
    m_bResetCaption = False
    UserControl_Paint
End Property

Public Property Get CurrentTab() As Integer
Attribute CurrentTab.VB_Description = "Returns/sets the active tab number."
Attribute CurrentTab.VB_MemberFlags = "200"
    CurrentTab = m_nCurrentTab
End Property

Public Property Let CurrentTab(ByVal vNewValue As Integer)
    If vNewValue >= 0 And vNewValue <= m_nTabs - 1 Then
        m_nCurrentTab = vNewValue
    Else
        m_nCurrentTab = 0
    End If
    PropertyChanged "CurrentTab"
    UserControl_Paint
End Property

Public Property Get TabCaption(ByVal Index As Integer) As String
    If Index >= 0 And Index <= m_nTabs - 1 Then
        TabCaption = m_tTab(Index).sCaption
    Else
        Err.Raise 9
    End If
End Property

Public Property Let TabCaption(ByVal Index As Integer, ByVal vNewValue As String)
    If Index >= 0 And Index <= m_nTabs - 1 Then
        m_tTab(Index).sCaption = vNewValue
        PropertyChanged "TabCaption" & CStr(Index)
        m_bResetCaption = False
        UserControl_Paint
    Else
        Err.Raise 9
    End If
End Property

Public Property Get Tabs() As Integer
Attribute Tabs.VB_Description = "Returns/sets the number of tabs."
    Tabs = m_nTabs
End Property

Public Property Let Tabs(ByVal vNewValue As Integer)
    If vNewValue > 0 Then
        m_nTabs = vNewValue
        PropertyChanged "Tabs"
        ReDim Preserve m_tTab(m_nTabs - 1)
        m_nCurrentTab = 0
        PropertyChanged "CurrentTab"
        m_bResetCaption = False
        UserControl_Paint
    End If
End Property

Public Property Get Caption() As String
Attribute Caption.VB_Description = "Returns/sets the text displayed in the active tab."
    Caption = Me.TabCaption(m_nCurrentTab)
End Property

Public Property Let Caption(ByVal vNewValue As String)
    Me.TabCaption(m_nCurrentTab) = vNewValue
End Property

Public Property Get Style() As oclTabStyleEnum
Attribute Style.VB_Description = "Returns/sets the style of the tabs."
    Style = m_Style
End Property

Public Property Let Style(ByVal vNewValue As oclTabStyleEnum)
    m_Style = vNewValue
    PropertyChanged "Style"
    m_bResetCaption = False
    UserControl_Paint
End Property

Public Property Get TabIcon(ByVal Index As Integer) As StdPicture
    If Index >= 0 And Index <= m_nTabs - 1 Then
        Set TabIcon = m_tTab(Index).Icon
    Else
        Err.Raise 9
    End If
End Property

Public Property Set TabIcon(ByVal Index As Integer, ByVal vNewValue As StdPicture)
    If Index >= 0 And Index <= m_nTabs - 1 Then
        Set m_tTab(Index).Icon = vNewValue
        PropertyChanged "TabIcon" & CStr(Index)
        m_bResetCaption = False
        UserControl_Paint
    Else
        Err.Raise 9
    End If
End Property

Public Property Get Icon() As StdPicture
Attribute Icon.VB_Description = "Returns/sets the icon displayed in the active tab."
    Set Icon = Me.TabIcon(m_nCurrentTab)
End Property

Public Property Set Icon(ByVal vNewValue As StdPicture)
    Set Me.TabIcon(m_nCurrentTab) = vNewValue
End Property

Public Property Get ShowFocusRect() As Boolean
Attribute ShowFocusRect.VB_Description = "Returns/sets a value that determines whether a focus rectangle will be drawn in the caption when the control has the focus."
    ShowFocusRect = m_bShowFocusRect
End Property

Public Property Let ShowFocusRect(ByVal vNewValue As Boolean)
    m_bShowFocusRect = vNewValue
    PropertyChanged "ShowFocusRect"
    UserControl_Paint
End Property

Public Property Get HotTracking() As Boolean
Attribute HotTracking.VB_Description = "Returns/sets a value that determines whether the tab under the cursor is highlighted."
    HotTracking = m_bHotTracking
End Property

Public Property Let HotTracking(ByVal vNewValue As Boolean)
    m_bHotTracking = vNewValue
    PropertyChanged "HotTracking"
    If Not m_bHotTracking Then
        m_nOverTab = -1
        UserControl_Paint
    End If
End Property

Public Property Get MouseIcon() As StdPicture
Attribute MouseIcon.VB_Description = "Returns/sets the icon used as the mouse pointer when the cursor is over the tabs."
    Set MouseIcon = m_MouseIcon
End Property

Public Property Set MouseIcon(ByVal vNewValue As StdPicture)
    Set m_MouseIcon = vNewValue
    PropertyChanged "MouseIcon"
    UserControl.MouseIcon = m_MouseIcon
End Property
